<?php
namespace Folha\Entities;

use HCM\Util\DateUtil;
use Importacao\Logic\Integracao\ProjetoImportacao;

class MigEstruturah extends Base\MigEstruturah
{

    const DEFAULT_IDOPTSIMPLES = 'N';
    const EXPRESSAO_NUMEROS = '/[^0-9]/';

//    /**
//     * @param $nrestruturah
//     * @return \Folha\Entities\MigEstruturah
//     */
//    public function setNrestruturah ($nrestruturah) {
//        $nrestruturah = \Importacao\Logic\Validacoes::verificaChaveDuplicada('ESTRUTURAH', 'NRESTRUTURAH', ProjetoImportacao::getNrorg(), $nrestruturah);
//        $this->nrestruturah = $nrestruturah;
//    }
//
//    /**
//     * @param $nrestruturam
//     * @throws \Exception
//     * @return \Folha\Entities\MigEstruturah
//     */
//    public function setNrestruturam ($nrestruturam) {
//        if (empty($nrestruturam)) {
//            throw new \Exception("Campo Obrigatório: 'Nº Estrutura'");
//        }
//
//        $nrestruturam = \Importacao\Logic\Validacoes::verificaChaveMae('ESTRUTURAM', 'NRESTRUTURAM', ProjetoImportacao::getNrorg(), $nrestruturam);
//        $this->nrestruturam = $nrestruturam;
//    }

    /**
     * @param $idoptsimples
     * @return \Folha\Entities\MigEstruturah
     */
    public function setIdoptsimples ($idoptsimples) {
        if (empty($idoptsimples)) {
            $idoptsimples = self::DEFAULT_IDOPTSIMPLES;
//            throw new \Exception("Campo Obrigatório: 'Optante Simples'");
        }

        $this->idoptsimples = $idoptsimples;
    }

    /**
     * @param mixed $dtinclusao
     * @throws \Exception
     * @return \Folha\Entities\MigEstruturah|void
     */
    public function setDtinclusao($dtinclusao)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtinclusao)) {
            throw new \Exception("Data '$dtinclusao' com formato inválido ou em branco.");
        }

        if (!($dtinclusao instanceof \DateTime)) {
            $dtinclusao = DateUtil::getDataDeString($dtinclusao);
        }

        $this->dtinclusao = $dtinclusao;
    }

    /**
     * @param mixed $dtultatu
     * @return \Folha\Entities\MigEstruturah|void
     */
    public function setDtultatu($dtultatu)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtultatu)) {
            throw new \Exception("Data '$dtultatu' com formato inválido ou em branco.");
        }

        if (!($dtultatu instanceof \DateTime)) {
            $dtultatu = DateUtil::getDataDeString($dtultatu);
        }

        $this->dtultatu = $dtultatu;
    }

    /**
     * @param mixed $dtmescompetenc
     * @return \Folha\Entities\MigEstruturah|void
     */
    public function setDtmescompetenc($dtmescompetenc)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtmescompetenc)) {
            throw new \Exception("Campo Obrigatório - Mês Competência: Data '$dtmescompetenc' com formato inválido ou em branco.");
        }

        if (!($dtmescompetenc instanceof \DateTime)) {
            $dtmescompetenc = DateUtil::getDataDeString($dtmescompetenc);
        }

        $this->dtmescompetenc = $dtmescompetenc;
    }

    /**
     * @param $dtbasesindical
     * @return \Folha\Entities\MigEstruturah
     */
    public function setDtbasesindical ($dtbasesindical)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtbasesindical)) {
            if (!empty($dtbasesindical)) {
                throw new \Exception("Base Sindical: Data '$dtbasesindical' com formato inválido ou em branco.");
            } else {
                throw new \Exception(null);
            }
        }

        if (!($dtbasesindical instanceof \DateTime)) {
            $dtbasesindical = DateUtil::getDataDeString($dtbasesindical);
        }

        $this->dtbasesindical = $dtbasesindical;
    }

    /**
     * @param $dtextincao
     * @throws \Exception
     * @return \Folha\Entities\MigEstruturah
     */
    public function setDtextincao ($dtextincao)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtextincao)) {
            if (!empty($dtextincao)) {
                throw new \Exception("Data '$dtextincao' com formato inválido ou em branco.");
            } else {
                throw new \Exception(null);
            }
        }

        if (!($dtextincao instanceof \DateTime)) {
            $dtextincao = DateUtil::getDataDeString($dtextincao);
        }

        $this->dtextincao = $dtextincao;
    }

    /**
     * @param $cdcnae
     * @return \Folha\Entities\MigEstruturah
     */
    public function setCdcnae ($cdcnae) {
        $cdcnae = preg_replace(self::EXPRESSAO_NUMEROS, "", $cdcnae);
        $cdcnae = substr($cdcnae, 0, 7);
        $this->cdcnae = $cdcnae;
    }

    /**
     * @param $cdcnpjestrut
     * @return \Folha\Entities\MigEstruturah
     */
    public function setCdcnpjestrut ($cdcnpjestrut) {
        $cdcnpjestrut = preg_replace(self::EXPRESSAO_NUMEROS, "", $cdcnpjestrut);
        $this->cdcnpjestrut = $cdcnpjestrut;
    }

    /**
     * @param $cdcpfestrutura
     * @return \Folha\Entities\MigEstruturah
     */
    public function setCdcpfestrutura ($cdcpfestrutura) {
        $cdcpfestrutura = preg_replace(self::EXPRESSAO_NUMEROS, "", $cdcpfestrutura);
        $this->cdcpfestrutura = $cdcpfestrutura;
    }

    /**
     * @param $cdceiestrut
     * @return \Folha\Entities\MigEstruturah
     */
    public function setCdceiestrut ($cdceiestrut) {
        $cdceiestrut = preg_replace(self::EXPRESSAO_NUMEROS, "", $cdceiestrut);
        $this->cdceiestrut = $cdceiestrut;
    }

    /**
     * @param $cdfpas
     * @return \Folha\Entities\MigEstruturah
     */
    public function setCdfpas ($cdfpas) {
        $cdfpas = preg_replace(self::EXPRESSAO_NUMEROS, "", $cdfpas);
        $this->cdfpas = $cdfpas;
    }

    /**
     * @param $nmestruturah
     * @return \Folha\Entities\MigEstruturah
     */
    public function setNmestruturah ($nmestruturah) {
        $nmestruturah = substr($nmestruturah, 0, 50);
        $this->nmestruturah = $nmestruturah;
    }

    /**
     * @param $nmfantasia
     * @return \Folha\Entities\MigEstruturah
     */
    public function setNmfantasia ($nmfantasia) {
        $nmfantasia = substr($nmfantasia, 0, 50);
        $this->nmfantasia = $nmfantasia;
    }

    /**
     * @param $nmrazsocestrut
     * @return \Folha\Entities\MigEstruturah
     */
    public function setNmrazsocestrut ($nmrazsocestrut) {
        $nmrazsocestrut = substr($nmrazsocestrut, 0, 50);
        $this->nmrazsocestrut = $nmrazsocestrut;
    }

    /**
     * @param $nrcaged
     * @return \Folha\Entities\MigEstruturah
     */
    public function setNrcaged ($nrcaged) {
        $nrcaged = preg_replace(self::EXPRESSAO_NUMEROS, "", $nrcaged);
        $this->nrcaged = $nrcaged;
    }

    /**
     * @param $cdsindical
     * @return \Folha\Entities\MigEstruturah
     */
    public function setCdsindical ($cdsindical) {
        $cdsindical = preg_replace(self::EXPRESSAO_NUMEROS, "", $cdsindical);
        $cdsindical = substr($cdsindical, 0, 15);
        $this->cdsindical = $cdsindical;
    }

}