/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOEQUI                                                      */
/* Tabela : TIPOEQUI                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 27/04/2006 - Arnaldo Coutinho Brito Jnior                                       */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPOEQUI'   and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATUTPEQ
GO

CREATE TRIGGER DTULTATU_TIPOEQUI
ON TIPOEQUI
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOEQUI', null, 'CDTIPOEQUI='+CDTIPOEQUI+';'+'NMTIPOEQUI='+NMTIPOEQUI+';'+'TXOBSTIPEQUI='+TXOBSTIPEQUI+';+'IDAGRUPPLANO='+IDAGRUPPLANO+';',
			       GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPOEQUI
      SET DTULTATUTPEQ = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TIPOEQUI.CDTIPOEQUI,0) = ISNULL(INSERTED.CDTIPOEQUI,0)) AND
            (ISNULL(TIPOEQUI.NMTIPOEQUI,0)   = ISNULL(INSERTED.NMTIPOEQUI,0)) AND
            (ISNULL(TIPOEQUI.TXOBSTIPEQUI,0) = ISNULL(INSERTED.TXOBSTIPEQUI,0)) AND
            (ISNULL(TIPOEQUI.IDAGRUPPLANO,0)   = ISNULL(INSERTED.IDAGRUPPLANO,0));
           
   END;
END;
GO
